package de.spring.sensors
{
	import flash.net.NetStream;

	public class NetStreamAdapter implements StreamAdapter
	{
		
		private var meta:Meta;
		private var netstream:NetStream;
		private var client:Object;
		
		private var duration:int;
		private var width:int;
		private var height:int;
		
		
		public function NetStreamAdapter(ns:NetStream, duration:int=0, width:int=0, height:int=0, captureEvents:Boolean=true)
		{
			this.netstream = ns;
			this.meta = new FlashMeta();
			
			this.duration = duration;
			this.width = width;
			this.height = height;
			
			// reassign client, hook in and use the old client as a delegate
			if(captureEvents) {
				client = ns.client;
				ns.client = this;
				trace("spring> reassigned client");
			}
		}
		
		public function getMeta():Meta
		{
			return meta;
		}
		
		public function getPosition():int
		{
			return Math.round(netstream.time);
		}
		
		public function getDuration():int
		{
			return this.duration;
		}
		
		public function getWidth():int
		{
			return this.width;
		}
		
		public function getHeight():int
		{
			return this.height;
		}
		
		// metadata handling
		// onCuePoint(), onImageData(), onMetaData(), onPlayStatus(), onTextData(), and onXMPData(). 
		
		public function onCuePoint(info:Object):void {
			if(client) client.onCuePoint(info);	
		}
		public function onImageData(info:Object):void {
			if(client) client.onImageData(info);	
		}
		public function onMetaData(info:Object):void {
			if(info.duration) duration = info.duration;
			if(info.width) width = info.width;
			if(info.height) height = info.height;
			
			if(client) client.onMetaData(info);	
		}
		public function onPlayStatus(info:Object):void {
			if(client) client.onPlayStatus(info);	
		}
		public function onTextData(info:Object):void {
			if(client) client.onTextData(info);	
		}
		public function onXMLData(info:Object):void {
			if(client) client.onXMPData(info);	
		}

	}
}